<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>ConnectorReification xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../../apidocs/org/eclipse/papyrus/designer/components/modellibs/core/transformations/ConnectorReification.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/*****************************************************************************</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2013 CEA LIST.</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <em class="jxr_javadoccomment"> *  Ansgar Radermacher  ansgar.radermacher@cea.fr</em>
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <em class="jxr_javadoccomment"> *****************************************************************************/</em>
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.components.modellibs.core.transformations;
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.BasicEList;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.EList;
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.components.FCM.InteractionComponent;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.components.modellibs.core.utils.CompDepUtils;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.components.transformation.Messages;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.components.transformation.PortUtils;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.components.transformation.sync.CompImplSync;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.components.transformation.templates.ConnectorBinding;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.components.transformation.templates.TemplateUtils;
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.deployment.tools.AllocUtils;
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.deployment.tools.DepUtils;
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.base.utils.CopyUtils;
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.base.utils.ElementUtils;
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.base.utils.TransformationException;
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.core.m2minterfaces.IM2MTrafoCDP;
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.core.templates.TemplateInstantiation;
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.core.transformations.LazyCopier;
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.core.transformations.TransformationContext;
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.profile.Transformation.M2MTrafo;
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.infra.core.Activator;
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.uml.tools.utils.ConnectorUtil;
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.uml.tools.utils.StereotypeUtil;
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Class;
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Classifier;
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.ConnectableElement;
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Connector;
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.ConnectorEnd;
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.EncapsulatedClassifier;
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.InstanceSpecification;
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Package;
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Port;
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Property;
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.TemplateBinding;
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Type;
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.util.UMLUtil;
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  <em class="jxr_javadoccomment"> * This class enables the reification of connectors, i.e. the replacement of</em>
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  <em class="jxr_javadoccomment"> * a UML connector with an interaction component. Reification is primarily</em>
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  <em class="jxr_javadoccomment"> * done on the level of a composite class.</em>
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/components/modellibs/core/transformations/ConnectorReification.html">ConnectorReification</a> <strong class="jxr_keyword">implements</strong> IM2MTrafoCDP {
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  <em class="jxr_javadoccomment">	 * Find a port that would match a connection</em>
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  <em class="jxr_javadoccomment">	 * @param connectorType</em>
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  <em class="jxr_javadoccomment">	 *            a connector type, i.e. a component with ports</em>
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  <em class="jxr_javadoccomment">	 * @param the</em>
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  <em class="jxr_javadoccomment">	 *            port on the other side of the connection</em>
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  <em class="jxr_javadoccomment">	 * @return the first port (of all ports owned or inherited by the type) that</em>
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  <em class="jxr_javadoccomment">	 *         is compatible with the passed otherPort.</em>
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Port getConnectorPort(EncapsulatedClassifier connectorType, Port otherPort, <strong class="jxr_keyword">boolean</strong> isAssembly) {
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  		EList&lt;Port&gt; ports = PortUtils.getAllPorts(connectorType);
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  		<em class="jxr_comment">// try to find matching port</em>
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  		<strong class="jxr_keyword">for</strong> (Port port : ports) {
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  			<strong class="jxr_keyword">if</strong> (PortUtils.isCompatible(port, otherPort, isAssembly)) {
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  				<strong class="jxr_keyword">return</strong> port;
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  			}
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  		}
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  		<strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> RuntimeException(String.format(Messages.ConnectorReification_CannotFindMatchingPort, connectorType.getName(), otherPort.getQualifiedName()));
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  	}
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  <em class="jxr_javadoccomment">	 * Simple helper function that finds the opposite connector end when one is given.</em>
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  <em class="jxr_javadoccomment">	 * If returns the first connector end that is not equal to the passed one, but results</em>
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  <em class="jxr_javadoccomment">	 * will not be useful in general for n-ary connectors (n!=2)</em>
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  <em class="jxr_javadoccomment">	 * </em>
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  <em class="jxr_javadoccomment">	 * @param connector</em>
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  <em class="jxr_javadoccomment">	 *            a connector</em>
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  <em class="jxr_javadoccomment">	 * @param myEnd</em>
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  <em class="jxr_javadoccomment">	 *            one end of a connector.</em>
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  <em class="jxr_javadoccomment">	 * @return the connector end that is associated with the "other" end of a</em>
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  <em class="jxr_javadoccomment">	 *         connection, i.e. the end that differs from the passed connector end</em>
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> ConnectorEnd oppositeConnEnd(Connector connector, ConnectorEnd myEnd) {
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  		<em class="jxr_comment">// look for the other end (connectedEnd != myEnd)</em>
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  		<strong class="jxr_keyword">for</strong> (ConnectorEnd end : connector.getEnds()) {
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  			<strong class="jxr_keyword">if</strong> (end != myEnd) {
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  				<strong class="jxr_keyword">return</strong> end;
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  			}
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  		}
<a class="jxr_linenumber" name="L100" href="#L100">100</a> 		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L101" href="#L101">101</a> 	}
<a class="jxr_linenumber" name="L102" href="#L102">102</a> 
<a class="jxr_linenumber" name="L103" href="#L103">103</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L104" href="#L104">104</a> <em class="jxr_javadoccomment">	 * Reify a connector already represented in form of a part (useful for n-ary connectors)</em>
<a class="jxr_linenumber" name="L105" href="#L105">105</a> <em class="jxr_javadoccomment">	 * </em>
<a class="jxr_linenumber" name="L106" href="#L106">106</a> <em class="jxr_javadoccomment">	 * @param composite</em>
<a class="jxr_linenumber" name="L107" href="#L107">107</a> <em class="jxr_javadoccomment">	 *            containing composite in target target model</em>
<a class="jxr_linenumber" name="L108" href="#L108">108</a> <em class="jxr_javadoccomment">	 * @param connectorPart</em>
<a class="jxr_linenumber" name="L109" href="#L109">109</a> <em class="jxr_javadoccomment">	 *            Part representing the connector</em>
<a class="jxr_linenumber" name="L110" href="#L110">110</a> <em class="jxr_javadoccomment">	 * @param compositeIS</em>
<a class="jxr_linenumber" name="L111" href="#L111">111</a> <em class="jxr_javadoccomment">	 *            target instance specification of the composite passed as 2nd parameter</em>
<a class="jxr_linenumber" name="L112" href="#L112">112</a> <em class="jxr_javadoccomment">	 *            (required for obtaining node allocation and choosing the right implementation.</em>
<a class="jxr_linenumber" name="L113" href="#L113">113</a> <em class="jxr_javadoccomment">	 *            Main use: decide whether a distributed implementation of an interaction component needs to be used)</em>
<a class="jxr_linenumber" name="L114" href="#L114">114</a> <em class="jxr_javadoccomment">	 * @return The created part within tmComponent that represents the reified</em>
<a class="jxr_linenumber" name="L115" href="#L115">115</a> <em class="jxr_javadoccomment">	 *         connector</em>
<a class="jxr_linenumber" name="L116" href="#L116">116</a> <em class="jxr_javadoccomment">	 * @throws TransformationException</em>
<a class="jxr_linenumber" name="L117" href="#L117">117</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L118" href="#L118">118</a> 	<strong class="jxr_keyword">public</strong> Property reifyConnector(Class composite, Property connectorPart, InstanceSpecification compositeIS) <strong class="jxr_keyword">throws</strong> TransformationException {
<a class="jxr_linenumber" name="L119" href="#L119">119</a> 
<a class="jxr_linenumber" name="L120" href="#L120">120</a> 		LazyCopier copier = TransformationContext.current.copier;
<a class="jxr_linenumber" name="L121" href="#L121">121</a> 
<a class="jxr_linenumber" name="L122" href="#L122">122</a> 		<strong class="jxr_keyword">if</strong> (!(connectorPart.getType() instanceof Class)) {
<a class="jxr_linenumber" name="L123" href="#L123">123</a> 			<em class="jxr_comment">// type is not a class, now check whether it is an interaction component</em>
<a class="jxr_linenumber" name="L124" href="#L124">124</a> 			<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L125" href="#L125">125</a> 		}
<a class="jxr_linenumber" name="L126" href="#L126">126</a> 		Class connImplementation = (Class) connectorPart.getType();
<a class="jxr_linenumber" name="L127" href="#L127">127</a> 		<strong class="jxr_keyword">if</strong> (!StereotypeUtil.isApplied(connImplementation, InteractionComponent.<strong class="jxr_keyword">class</strong>)) {
<a class="jxr_linenumber" name="L128" href="#L128">128</a> 			<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L129" href="#L129">129</a> 		}
<a class="jxr_linenumber" name="L130" href="#L130">130</a> 
<a class="jxr_linenumber" name="L131" href="#L131">131</a> 		<em class="jxr_comment">// choose an implementation</em>
<a class="jxr_linenumber" name="L132" href="#L132">132</a> 		Class connectorImplemTemplate = CompDepUtils.chooseImplementation(connImplementation, AllocUtils.getAllNodes(compositeIS), <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L133" href="#L133">133</a> 
<a class="jxr_linenumber" name="L134" href="#L134">134</a> 		TemplateBinding binding = ConnectorBinding.obtainBinding(composite, connectorPart, connectorImplemTemplate, <strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="L135" href="#L135">135</a> 		Class connectorImplem;
<a class="jxr_linenumber" name="L136" href="#L136">136</a> 
<a class="jxr_linenumber" name="L137" href="#L137">137</a> 		<strong class="jxr_keyword">if</strong> (binding != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L138" href="#L138">138</a> 			TemplateUtils.adaptActualsToTargetModel(copier, binding);
<a class="jxr_linenumber" name="L139" href="#L139">139</a> 			TemplateInstantiation ti = <strong class="jxr_keyword">new</strong> TemplateInstantiation(binding);
<a class="jxr_linenumber" name="L140" href="#L140">140</a> 			connectorImplem = ti.bindElement(connectorImplemTemplate);
<a class="jxr_linenumber" name="L141" href="#L141">141</a> 		} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L142" href="#L142">142</a> 			<em class="jxr_comment">// no binding, class is not a template =&gt; copy as it is</em>
<a class="jxr_linenumber" name="L143" href="#L143">143</a> 			connectorImplem = copier.getCopy(connectorImplemTemplate);
<a class="jxr_linenumber" name="L144" href="#L144">144</a> 		}
<a class="jxr_linenumber" name="L145" href="#L145">145</a> 		Property tmConnectorPart = copier.getCopy(connectorPart);
<a class="jxr_linenumber" name="L146" href="#L146">146</a> 		tmConnectorPart.setType(connectorImplem);
<a class="jxr_linenumber" name="L147" href="#L147">147</a> 		<em class="jxr_comment">// now re-target connectors towards this part</em>
<a class="jxr_linenumber" name="L148" href="#L148">148</a> 		TemplateUtils.retargetConnectors(composite, tmConnectorPart);
<a class="jxr_linenumber" name="L149" href="#L149">149</a> 		<strong class="jxr_keyword">return</strong> tmConnectorPart;
<a class="jxr_linenumber" name="L150" href="#L150">150</a> 	}
<a class="jxr_linenumber" name="L151" href="#L151">151</a> 
<a class="jxr_linenumber" name="L152" href="#L152">152</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L153" href="#L153">153</a> <em class="jxr_javadoccomment">	 * Reify a connector</em>
<a class="jxr_linenumber" name="L154" href="#L154">154</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L155" href="#L155">155</a> <em class="jxr_javadoccomment">	 * @param composite</em>
<a class="jxr_linenumber" name="L156" href="#L156">156</a> <em class="jxr_javadoccomment">	 *            containing composite</em>
<a class="jxr_linenumber" name="L157" href="#L157">157</a> <em class="jxr_javadoccomment">	 * @param connector</em>
<a class="jxr_linenumber" name="L158" href="#L158">158</a> <em class="jxr_javadoccomment">	 *            connector within the passed composite. If connector reification is successful, the passed connector will be destroyed</em>
<a class="jxr_linenumber" name="L159" href="#L159">159</a> <em class="jxr_javadoccomment">	 *            (since replaced by a new connector-part-connector combination)</em>
<a class="jxr_linenumber" name="L160" href="#L160">160</a> <em class="jxr_javadoccomment">	 * @param compositeIS</em>
<a class="jxr_linenumber" name="L161" href="#L161">161</a> <em class="jxr_javadoccomment">	 *            instance specification of the composite passed as 2nd parameter</em>
<a class="jxr_linenumber" name="L162" href="#L162">162</a> <em class="jxr_javadoccomment">	 *            (required for obtaining node allocation and choosing the right implementation.</em>
<a class="jxr_linenumber" name="L163" href="#L163">163</a> <em class="jxr_javadoccomment">	 *            Main use: decide whether a distributed implementation of an interaction component needs to be used)</em>
<a class="jxr_linenumber" name="L164" href="#L164">164</a> <em class="jxr_javadoccomment">	 * @return the created part within the composite or null, if no reification could be executed.</em>
<a class="jxr_linenumber" name="L165" href="#L165">165</a> <em class="jxr_javadoccomment">	 * @throws TransformationException</em>
<a class="jxr_linenumber" name="L166" href="#L166">166</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L167" href="#L167">167</a> 	<strong class="jxr_keyword">public</strong> Property reifyConnector(Class composite, Connector connector, InstanceSpecification compositeIS) <strong class="jxr_keyword">throws</strong> TransformationException {
<a class="jxr_linenumber" name="L168" href="#L168">168</a> 
<a class="jxr_linenumber" name="L169" href="#L169">169</a> 		InteractionComponent connType = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L170" href="#L170">170</a> 		org.eclipse.papyrus.designer.components.FCM.Connector fcmConn = UMLUtil.getStereotypeApplication(connector, org.eclipse.papyrus.designer.components.FCM.Connector.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L171" href="#L171">171</a> 		<strong class="jxr_keyword">if</strong> (fcmConn != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L172" href="#L172">172</a> 			connType = fcmConn.getIc();
<a class="jxr_linenumber" name="L173" href="#L173">173</a> 		}
<a class="jxr_linenumber" name="L174" href="#L174">174</a> 		<strong class="jxr_keyword">if</strong> (connType == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L175" href="#L175">175</a> 			<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L176" href="#L176">176</a> 		}
<a class="jxr_linenumber" name="L177" href="#L177">177</a> 
<a class="jxr_linenumber" name="L178" href="#L178">178</a> 		LazyCopier copier = TransformationContext.current.copier;
<a class="jxr_linenumber" name="L179" href="#L179">179</a> 		String name = ElementUtils.varName(connector);
<a class="jxr_linenumber" name="L180" href="#L180">180</a> 
<a class="jxr_linenumber" name="L181" href="#L181">181</a> 		<em class="jxr_comment">// choose an implementation</em>
<a class="jxr_linenumber" name="L182" href="#L182">182</a> 		Class connectorImplemTemplate = DepUtils.chooseImplementation(connType.getBase_Class(), AllocUtils.getAllNodes(compositeIS), <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L183" href="#L183">183</a> 
<a class="jxr_linenumber" name="L184" href="#L184">184</a> 		<em class="jxr_comment">// ---- obtain binding &amp; instantiate template type ...</em>
<a class="jxr_linenumber" name="L185" href="#L185">185</a> 		TemplateBinding binding = ConnectorBinding.obtainBinding(composite, connector, connectorImplemTemplate, <strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="L186" href="#L186">186</a> 		Class connectorImplem;
<a class="jxr_linenumber" name="L187" href="#L187">187</a> 
<a class="jxr_linenumber" name="L188" href="#L188">188</a> 		<strong class="jxr_keyword">if</strong> (binding != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L189" href="#L189">189</a> 			TemplateUtils.adaptActualsToTargetModel(copier, binding);
<a class="jxr_linenumber" name="L190" href="#L190">190</a> 			<em class="jxr_comment">// make copy of bound package and restore it later. Required for nested template instantiations, in particular</em>
<a class="jxr_linenumber" name="L191" href="#L191">191</a> 			<em class="jxr_comment">// the bound package is set within container transformations and is (by default) restored to "null" afterwards.</em>
<a class="jxr_linenumber" name="L192" href="#L192">192</a> 			<em class="jxr_comment">// TODO: TemplateInstantiation should do this automatically</em>
<a class="jxr_linenumber" name="L193" href="#L193">193</a> 			copier.pushPackageTemplate();
<a class="jxr_linenumber" name="L194" href="#L194">194</a> 			TemplateInstantiation ti = <strong class="jxr_keyword">new</strong> TemplateInstantiation(binding);
<a class="jxr_linenumber" name="L195" href="#L195">195</a> 			connectorImplem = ti.bindElement(connectorImplemTemplate);
<a class="jxr_linenumber" name="L196" href="#L196">196</a> 			copier.popPackageTemplate();
<a class="jxr_linenumber" name="L197" href="#L197">197</a> 		} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L198" href="#L198">198</a> 			<em class="jxr_comment">// no binding, class is not a template =&gt; copy as it is</em>
<a class="jxr_linenumber" name="L199" href="#L199">199</a> 			connectorImplem = copier.getCopy(connectorImplemTemplate);
<a class="jxr_linenumber" name="L200" href="#L200">200</a> 		}
<a class="jxr_linenumber" name="L201" href="#L201">201</a> 
<a class="jxr_linenumber" name="L202" href="#L202">202</a> 		<strong class="jxr_keyword">if</strong> (connectorImplem == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L203" href="#L203">203</a> 			<strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> TransformationException(String.format(Messages.ConnectorReification_CouldNotBind, connectorImplemTemplate.getName()));
<a class="jxr_linenumber" name="L204" href="#L204">204</a> 		}
<a class="jxr_linenumber" name="L205" href="#L205">205</a> 
<a class="jxr_linenumber" name="L206" href="#L206">206</a> 		Property tmConnectorPart = composite.createOwnedAttribute(name, connectorImplemTemplate);
<a class="jxr_linenumber" name="L207" href="#L207">207</a> 		<em class="jxr_comment">// copy id, but prefix it with "p" (for part)</em>
<a class="jxr_linenumber" name="L208" href="#L208">208</a> 		CopyUtils.copyID(connector, tmConnectorPart, <span class="jxr_string">"p"</span>); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L209" href="#L209">209</a> 		tmConnectorPart.setIsComposite(<strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="L210" href="#L210">210</a> 
<a class="jxr_linenumber" name="L211" href="#L211">211</a> 		Activator.log.info(String.format(Messages.ConnectorReification_InfoAddConnectorPart, connectorImplemTemplate.getName(), connectorImplem.getName()));
<a class="jxr_linenumber" name="L212" href="#L212">212</a> 
<a class="jxr_linenumber" name="L213" href="#L213">213</a> 		<em class="jxr_comment">// now create (simple) connections towards the new part</em>
<a class="jxr_linenumber" name="L214" href="#L214">214</a> 		<strong class="jxr_keyword">int</strong> i = 0;
<a class="jxr_linenumber" name="L215" href="#L215">215</a> 		<strong class="jxr_keyword">for</strong> (ConnectorEnd smEnd : connector.getEnds()) {
<a class="jxr_linenumber" name="L216" href="#L216">216</a> 			Connector tmConnector = composite.createOwnedConnector(<span class="jxr_string">"c "</span> <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L217" href="#L217">217</a> 					+ name + <span class="jxr_string">" "</span> + String.valueOf(i)); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L218" href="#L218">218</a> 			CopyUtils.copyID(connector, tmConnector);
<a class="jxr_linenumber" name="L219" href="#L219">219</a> 			i++;
<a class="jxr_linenumber" name="L220" href="#L220">220</a> 			<em class="jxr_comment">// the new connector connects the existing end with an end of the</em>
<a class="jxr_linenumber" name="L221" href="#L221">221</a> 			<em class="jxr_comment">// reified connector (the newly created property.)</em>
<a class="jxr_linenumber" name="L222" href="#L222">222</a> 
<a class="jxr_linenumber" name="L223" href="#L223">223</a> 			<em class="jxr_comment">// --- first end, connected with the existing end (of another non-connector part)</em>
<a class="jxr_linenumber" name="L224" href="#L224">224</a> 			ConnectorEnd tmEnd1 = tmConnector.createEnd();
<a class="jxr_linenumber" name="L225" href="#L225">225</a> 			Property smPartWithPort = smEnd.getPartWithPort();
<a class="jxr_linenumber" name="L226" href="#L226">226</a> 			Property tmPartWithPort = copier.getCopy(smPartWithPort);
<a class="jxr_linenumber" name="L227" href="#L227">227</a> 			ConnectableElement smRole = smEnd.getRole();
<a class="jxr_linenumber" name="L228" href="#L228">228</a> 			ConnectableElement tmRole = copier.getCopy(smRole);
<a class="jxr_linenumber" name="L229" href="#L229">229</a> 			tmEnd1.setPartWithPort(tmPartWithPort);
<a class="jxr_linenumber" name="L230" href="#L230">230</a> 			tmEnd1.setRole(tmRole);
<a class="jxr_linenumber" name="L231" href="#L231">231</a> 
<a class="jxr_linenumber" name="L232" href="#L232">232</a> 			<em class="jxr_comment">// --- 2nd end, connected with the reified connector (new part)</em>
<a class="jxr_linenumber" name="L233" href="#L233">233</a> 			ConnectorEnd tmEnd2 = tmConnector.createEnd();
<a class="jxr_linenumber" name="L234" href="#L234">234</a> 			tmEnd2.setPartWithPort(tmConnectorPart);
<a class="jxr_linenumber" name="L235" href="#L235">235</a> 			<em class="jxr_comment">// inheritance between connector type and implementation (ports should be identical)</em>
<a class="jxr_linenumber" name="L236" href="#L236">236</a> 			<em class="jxr_comment">// TODO: check whether filter condition is unique? (first returned by getConnectorPort is "good" one)</em>
<a class="jxr_linenumber" name="L237" href="#L237">237</a> 			<strong class="jxr_keyword">if</strong> (tmRole instanceof Port) {
<a class="jxr_linenumber" name="L238" href="#L238">238</a> 				tmEnd2.setRole(getConnectorPort(connectorImplem, (Port) tmRole, (tmPartWithPort != <strong class="jxr_keyword">null</strong>)));
<a class="jxr_linenumber" name="L239" href="#L239">239</a> 			} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L240" href="#L240">240</a> 				<strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> TransformationException(Messages.ConnectorReification_RequiresUseOfPorts);
<a class="jxr_linenumber" name="L241" href="#L241">241</a> 			}
<a class="jxr_linenumber" name="L242" href="#L242">242</a> 		}
<a class="jxr_linenumber" name="L243" href="#L243">243</a> 
<a class="jxr_linenumber" name="L244" href="#L244">244</a> 		tmConnectorPart.setType(connectorImplem);
<a class="jxr_linenumber" name="L245" href="#L245">245</a> 		<em class="jxr_comment">// updatePorts(tmComponent, connectorPart, connectorImplem);</em>
<a class="jxr_linenumber" name="L246" href="#L246">246</a> 		<em class="jxr_comment">// connectContainerPorts(tmComponent, connectorPart);</em>
<a class="jxr_linenumber" name="L247" href="#L247">247</a> 		connector.destroy();
<a class="jxr_linenumber" name="L248" href="#L248">248</a> 
<a class="jxr_linenumber" name="L249" href="#L249">249</a> 		<strong class="jxr_keyword">return</strong> tmConnectorPart;
<a class="jxr_linenumber" name="L250" href="#L250">250</a> 	}
<a class="jxr_linenumber" name="L251" href="#L251">251</a> 
<a class="jxr_linenumber" name="L252" href="#L252">252</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L253" href="#L253">253</a> <em class="jxr_javadoccomment">	 * Components can contain additional ports that are inherited via the</em>
<a class="jxr_linenumber" name="L254" href="#L254">254</a> <em class="jxr_javadoccomment">	 * container extension. These ports should typically be connected with</em>
<a class="jxr_linenumber" name="L255" href="#L255">255</a> <em class="jxr_javadoccomment">	 * additional ports of the (reified) connector. This connection is based on</em>
<a class="jxr_linenumber" name="L256" href="#L256">256</a> <em class="jxr_javadoccomment">	 * equal port types and is done automatically by this function, i.e. it</em>
<a class="jxr_linenumber" name="L257" href="#L257">257</a> <em class="jxr_javadoccomment">	 * cannot be done by the developer.</em>
<a class="jxr_linenumber" name="L258" href="#L258">258</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L259" href="#L259">259</a> <em class="jxr_javadoccomment">	 * @param composite</em>
<a class="jxr_linenumber" name="L260" href="#L260">260</a> <em class="jxr_javadoccomment">	 *            the composite in which a connector has been reified.</em>
<a class="jxr_linenumber" name="L261" href="#L261">261</a> <em class="jxr_javadoccomment">	 * @param reifiedConnector</em>
<a class="jxr_linenumber" name="L262" href="#L262">262</a> <em class="jxr_javadoccomment">	 *            the part associated with the reifiedConnector</em>
<a class="jxr_linenumber" name="L263" href="#L263">263</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L264" href="#L264">264</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> connectContainerPorts(Class composite, Property reifiedConnector) {
<a class="jxr_linenumber" name="L265" href="#L265">265</a> 		<em class="jxr_comment">// This function is based on the assumption that the additional ports of the reified</em>
<a class="jxr_linenumber" name="L266" href="#L266">266</a> 		<em class="jxr_comment">// connector need to be connected with a port of a component that is already</em>
<a class="jxr_linenumber" name="L267" href="#L267">267</a> 		<em class="jxr_comment">// connected via the "normal" connectors (explicitly modeled by the user).</em>
<a class="jxr_linenumber" name="L268" href="#L268">268</a> 		<em class="jxr_comment">// For instance, in case of ACCORD-calls, the server component provides the additional</em>
<a class="jxr_linenumber" name="L269" href="#L269">269</a> 		<em class="jxr_comment">// RTU port via its container.</em>
<a class="jxr_linenumber" name="L270" href="#L270">270</a> 
<a class="jxr_linenumber" name="L271" href="#L271">271</a> 		<em class="jxr_comment">// Create a subset of connectors that are connected with the reified connector</em>
<a class="jxr_linenumber" name="L272" href="#L272">272</a> 		EList&lt;Connector&gt; connSubset = <strong class="jxr_keyword">new</strong> BasicEList&lt;Connector&gt;();
<a class="jxr_linenumber" name="L273" href="#L273">273</a> 		<strong class="jxr_keyword">for</strong> (Connector connector : composite.getOwnedConnectors()) {
<a class="jxr_linenumber" name="L274" href="#L274">274</a> 			<strong class="jxr_keyword">if</strong> (ConnectorUtil.connectsPart(connector, reifiedConnector)) {
<a class="jxr_linenumber" name="L275" href="#L275">275</a> 				connSubset.add(connector);
<a class="jxr_linenumber" name="L276" href="#L276">276</a> 			}
<a class="jxr_linenumber" name="L277" href="#L277">277</a> 		}
<a class="jxr_linenumber" name="L278" href="#L278">278</a> 
<a class="jxr_linenumber" name="L279" href="#L279">279</a> 		<strong class="jxr_keyword">for</strong> (Port port : PortUtils.getAllPorts((Class) reifiedConnector.getType())) {
<a class="jxr_linenumber" name="L280" href="#L280">280</a> 			<em class="jxr_comment">// check, if port is unconnected.</em>
<a class="jxr_linenumber" name="L281" href="#L281">281</a> 			<strong class="jxr_keyword">boolean</strong> connected = false;
<a class="jxr_linenumber" name="L282" href="#L282">282</a> 			<em class="jxr_comment">// check whether a port of the reified connector is not yet</em>
<a class="jxr_linenumber" name="L283" href="#L283">283</a> 			<em class="jxr_comment">// connected.</em>
<a class="jxr_linenumber" name="L284" href="#L284">284</a> 			<strong class="jxr_keyword">for</strong> (Connector connector : connSubset) {
<a class="jxr_linenumber" name="L285" href="#L285">285</a> 				<strong class="jxr_keyword">if</strong> (ConnectorUtil.connectsPort(connector, port)) {
<a class="jxr_linenumber" name="L286" href="#L286">286</a> 					connected = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L287" href="#L287">287</a> 				}
<a class="jxr_linenumber" name="L288" href="#L288">288</a> 			}
<a class="jxr_linenumber" name="L289" href="#L289">289</a> 			<strong class="jxr_keyword">if</strong> (!connected) {
<a class="jxr_linenumber" name="L290" href="#L290">290</a> 				<em class="jxr_comment">// port is not connected yet. Check to find a connectable port</em>
<a class="jxr_linenumber" name="L291" href="#L291">291</a> 				<em class="jxr_comment">// among all ports of connected parts.</em>
<a class="jxr_linenumber" name="L292" href="#L292">292</a> 				<em class="jxr_comment">// In the moment, we assume the processes is stopped, as soon as</em>
<a class="jxr_linenumber" name="L293" href="#L293">293</a> 				<em class="jxr_comment">// the port is connected, i.e. we do not want to connect the port to</em>
<a class="jxr_linenumber" name="L294" href="#L294">294</a> 				<em class="jxr_comment">// potentially set of ports (todo: restriction always useful?)</em>
<a class="jxr_linenumber" name="L295" href="#L295">295</a> 				<strong class="jxr_keyword">for</strong> (Connector connector : connSubset) {
<a class="jxr_linenumber" name="L296" href="#L296">296</a> 					ConnectorEnd connEnd = ConnectorUtil.connEndNotPart(connector, reifiedConnector);
<a class="jxr_linenumber" name="L297" href="#L297">297</a> 					Property otherPart = connEnd.getPartWithPort();
<a class="jxr_linenumber" name="L298" href="#L298">298</a> 					<em class="jxr_comment">// this is a part which is connected with the reified</em>
<a class="jxr_linenumber" name="L299" href="#L299">299</a> 					<em class="jxr_comment">// connector check whether one of its ports is compatible with the</em>
<a class="jxr_linenumber" name="L300" href="#L300">300</a> 					<em class="jxr_comment">// non-connected port.</em>
<a class="jxr_linenumber" name="L301" href="#L301">301</a> 					<strong class="jxr_keyword">if</strong> (!(otherPart.getType() instanceof EncapsulatedClassifier)) {
<a class="jxr_linenumber" name="L302" href="#L302">302</a> 						<strong class="jxr_keyword">continue</strong>;
<a class="jxr_linenumber" name="L303" href="#L303">303</a> 					}
<a class="jxr_linenumber" name="L304" href="#L304">304</a> 
<a class="jxr_linenumber" name="L305" href="#L305">305</a> 					<strong class="jxr_keyword">for</strong> (Port otherPort : PortUtils.getAllPorts((EncapsulatedClassifier) otherPart.getType())) {
<a class="jxr_linenumber" name="L306" href="#L306">306</a> 						Activator.log.info(String.format(Messages.ConnectorReification_InfoPortTypes, otherPort.getType().getQualifiedName(), port.getType().getQualifiedName()));
<a class="jxr_linenumber" name="L307" href="#L307">307</a> 						<strong class="jxr_keyword">if</strong> (otherPort.getType() == port.getType()) {
<a class="jxr_linenumber" name="L308" href="#L308">308</a> 							Connector newConnector = composite.createOwnedConnector(<span class="jxr_string">"connector - container of "</span> <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L309" href="#L309">309</a> 									+ otherPart.getName());
<a class="jxr_linenumber" name="L310" href="#L310">310</a> 							ConnectorEnd end1 = newConnector.createEnd();
<a class="jxr_linenumber" name="L311" href="#L311">311</a> 							ConnectorEnd end2 = newConnector.createEnd();
<a class="jxr_linenumber" name="L312" href="#L312">312</a> 							end1.setPartWithPort(reifiedConnector);
<a class="jxr_linenumber" name="L313" href="#L313">313</a> 							end1.setRole(port);
<a class="jxr_linenumber" name="L314" href="#L314">314</a> 							end2.setPartWithPort(otherPart);
<a class="jxr_linenumber" name="L315" href="#L315">315</a> 							end2.setRole(otherPort);
<a class="jxr_linenumber" name="L316" href="#L316">316</a> 							connected = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L317" href="#L317">317</a> 							<strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L318" href="#L318">318</a> 						}
<a class="jxr_linenumber" name="L319" href="#L319">319</a> 					}
<a class="jxr_linenumber" name="L320" href="#L320">320</a> 					<strong class="jxr_keyword">if</strong> (connected) {
<a class="jxr_linenumber" name="L321" href="#L321">321</a> 						<strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L322" href="#L322">322</a> 					}
<a class="jxr_linenumber" name="L323" href="#L323">323</a> 				}
<a class="jxr_linenumber" name="L324" href="#L324">324</a> 				<strong class="jxr_keyword">if</strong> (!connected) {
<a class="jxr_linenumber" name="L325" href="#L325">325</a> 					<strong class="jxr_keyword">if</strong> (port.getType() == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L326" href="#L326">326</a> 						Activator.log.debug(String.format(Messages.ConnectorReification_CouldNotConnectPort, port.getName()));
<a class="jxr_linenumber" name="L327" href="#L327">327</a> 					} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L328" href="#L328">328</a> 						Activator.log.debug(String.format(Messages.ConnectorReification_CouldNotConnectPortOfType, port.getName(), port.getType().getName()));
<a class="jxr_linenumber" name="L329" href="#L329">329</a> 					}
<a class="jxr_linenumber" name="L330" href="#L330">330</a> 				}
<a class="jxr_linenumber" name="L331" href="#L331">331</a> 			}
<a class="jxr_linenumber" name="L332" href="#L332">332</a> 		}
<a class="jxr_linenumber" name="L333" href="#L333">333</a> 	}
<a class="jxr_linenumber" name="L334" href="#L334">334</a> 
<a class="jxr_linenumber" name="L335" href="#L335">335</a> 	@Override
<a class="jxr_linenumber" name="L336" href="#L336">336</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> applyTrafo(M2MTrafo trafo, Package deploymentPlan) <strong class="jxr_keyword">throws</strong> TransformationException {
<a class="jxr_linenumber" name="L337" href="#L337">337</a> 		<strong class="jxr_keyword">for</strong> (InstanceSpecification is : DepUtils.getInstances(deploymentPlan)) {
<a class="jxr_linenumber" name="L338" href="#L338">338</a> 			Classifier cl = DepUtils.getClassifier(is);
<a class="jxr_linenumber" name="L339" href="#L339">339</a> 			<strong class="jxr_keyword">if</strong> (cl instanceof Class) {
<a class="jxr_linenumber" name="L340" href="#L340">340</a> 				Class clazz = (Class) cl;
<a class="jxr_linenumber" name="L341" href="#L341">341</a> 				EList&lt;Connector&gt; connectorListCopy = <strong class="jxr_keyword">new</strong> BasicEList&lt;Connector&gt;();
<a class="jxr_linenumber" name="L342" href="#L342">342</a> 				connectorListCopy.addAll(clazz.getOwnedConnectors());
<a class="jxr_linenumber" name="L343" href="#L343">343</a> 				<strong class="jxr_keyword">for</strong> (Connector connector : connectorListCopy) {
<a class="jxr_linenumber" name="L344" href="#L344">344</a> 					Class tmComponent = (Class) connector.getOwner();
<a class="jxr_linenumber" name="L345" href="#L345">345</a> 					Property newPart = reifyConnector(tmComponent, connector, is);
<a class="jxr_linenumber" name="L346" href="#L346">346</a> 					<em class="jxr_comment">// update value specification (to the one just created)</em>
<a class="jxr_linenumber" name="L347" href="#L347">347</a> 					<em class="jxr_comment">// InstanceSpecification tmPartIS = EcoreUtil.copy(DepUtils.getInstance(slot));</em>
<a class="jxr_linenumber" name="L348" href="#L348">348</a> 					<em class="jxr_comment">// if (tmPartIS.getClassifiers().size() &gt; 0) {</em>
<a class="jxr_linenumber" name="L349" href="#L349">349</a> 					<em class="jxr_comment">// replace classifier referenced from instance with type of reified connector</em>
<a class="jxr_linenumber" name="L350" href="#L350">350</a> 					<em class="jxr_comment">// tmPartIS.getClassifiers().set(0, (Classifier) tmPart.getType());</em>
<a class="jxr_linenumber" name="L351" href="#L351">351</a> 					<em class="jxr_comment">// TransformationUtil.updateDerivedInterfaces(tmPartIS);</em>
<a class="jxr_linenumber" name="L352" href="#L352">352</a> 					<em class="jxr_comment">// }</em>
<a class="jxr_linenumber" name="L353" href="#L353">353</a> 					<strong class="jxr_keyword">if</strong> (newPart != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L354" href="#L354">354</a> 						Type implCandidate = newPart.getType();
<a class="jxr_linenumber" name="L355" href="#L355">355</a> 						<strong class="jxr_keyword">if</strong> (implCandidate instanceof Class) {
<a class="jxr_linenumber" name="L356" href="#L356">356</a> 							Class implementation = (Class) implCandidate;
<a class="jxr_linenumber" name="L357" href="#L357">357</a> 							CompImplSync.updatePorts(implementation);
<a class="jxr_linenumber" name="L358" href="#L358">358</a> 							CompImplSync.syncRealizations(implementation);
<a class="jxr_linenumber" name="L359" href="#L359">359</a> 						}
<a class="jxr_linenumber" name="L360" href="#L360">360</a> 					}
<a class="jxr_linenumber" name="L361" href="#L361">361</a> 				}
<a class="jxr_linenumber" name="L362" href="#L362">362</a> 
<a class="jxr_linenumber" name="L363" href="#L363">363</a> 				EList&lt;Property&gt; attributeListCopy = <strong class="jxr_keyword">new</strong> BasicEList&lt;Property&gt;();
<a class="jxr_linenumber" name="L364" href="#L364">364</a> 				attributeListCopy.addAll(clazz.getAttributes());
<a class="jxr_linenumber" name="L365" href="#L365">365</a> 				<strong class="jxr_keyword">for</strong> (Property attribute : attributeListCopy) {
<a class="jxr_linenumber" name="L366" href="#L366">366</a> 
<a class="jxr_linenumber" name="L367" href="#L367">367</a> 					Class tmComponent = (Class) attribute.getOwner();
<a class="jxr_linenumber" name="L368" href="#L368">368</a> 					reifyConnector(tmComponent, attribute, is);
<a class="jxr_linenumber" name="L369" href="#L369">369</a> 				}
<a class="jxr_linenumber" name="L370" href="#L370">370</a> 			}
<a class="jxr_linenumber" name="L371" href="#L371">371</a> 		}
<a class="jxr_linenumber" name="L372" href="#L372">372</a> 	}
<a class="jxr_linenumber" name="L373" href="#L373">373</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
